#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
// #define _GNU_SOURCE
#include <string.h>

void *my_memmem(const void *haystack, size_t haystacklen,
             const void *needle, size_t needlelen) {
    size_t i;
    if (needlelen > haystacklen)
        return NULL;
    for (i=0; i<haystacklen-needlelen+1; i++)
        if (memcmp(haystack+i, needle, needlelen)==0)
            return (void *) haystack+i;
    return NULL;
}


char *in=NULL;
size_t inlen=0;
size_t inalloc=0;

void readin() {
    int rv=0;
    if (!in) {
        inalloc = 4096;
        in = (char *) malloc(inalloc);
    }
    if (!in) {
        perror("malloc");
        exit(1);
    }
    do {
        inlen += rv;
        if (inlen == inalloc) {
            inalloc *= 4;
            in = (char *) realloc(in, inalloc);
            if (!in) {
                perror("realloc");
                exit(1);
            }
        }
        rv = read(0, in + inlen, inalloc - inlen);
    } while (rv > 0);
    if (rv < 0) {
        perror("read");
        exit(1);
    }
}

void writeout() {
    size_t i;
    int rv;
    for (i=0; i < inlen; i += rv) {
        rv = write(1, in + i, inlen - i);
        if (rv <= 0) {
            perror("write");
            exit(1);
        }
    }
}

void filter() {
    char *banned[] = { "text/javascript", "javascript:", };
    int j, doitagain;
    char *p;
    while (doitagain) {
        doitagain = 0;
        for (j=0; j<sizeof(banned)/sizeof(char *); j++) {
            p = my_memmem(in, inlen, banned[j], strlen(banned[j]));
            if (p != NULL) {
                memset(p, 'X', strlen(banned[j]));
                doitagain = 1;
            }
        }
    }
}

int main(int argc, char **argv) {
    readin();
    filter();
    writeout();
    return 0;
}
